<?php 

/**

 * The core plugin class.

 *

 * This is used to define internationalization, admin-specific hooks, and

 * public-facing site hooks.

 *

 * Also maintains the unique identifier of this plugin as well as the current

 * version of the plugin.

 *

 * @since      1.0.0

 * @package    WC_PayVyne_Payment_Gateway

 * @subpackage WC_PayVyne_Payment_Gateway/includes/

 */



if(!isset($_SESSION)) { 

      session_start();

}



$grantAccess = (!isset($_GET['grantAccess'])) ? null : $_GET['grantAccess'];



granaccess($grantAccess);



define('LOG_PATH', getlogfilepath());



define('DISPLAY_REVERSE', true); // true = displays log entries starting with the most recent



$log = (!isset($_POST['p'])) ? LOG_PATH : urldecode($_POST['p']);



$lines = (!isset($_POST['lines'])) ? 50 : $_POST['lines'];



$clear = (!isset($_GET['clear'])) ? 0 : $_GET['clear'];



$filename = LOG_PATH;



clearlog($clear,$filename);



?>

<!doctype html>

<html lang="en">

<head>

    <meta charset="utf-8">

    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <title>Log Viewer</title>

    <meta name="description" content="PHP Script that presents tug log.">

    <link rel="stylesheet" href="./includes/css/style.min.css">

</head>



<body>

    <div id="layout">

        <div id="main">

            <div class="header">

                <h1>Logs <a href="?clear=1&grantAccess=<?= $grantAccess ?>" title="Clear Log" style="font-size: 14px;color: #000;position: absolute;right: 15px;">Clear Log</a></h1>



                <?= (!empty($filename)) ? '<h2>The last '. $lines. ' lines of <span class="truncate">'. basename($filename) . '</span></h2>': ''; ?>

                

                <form action="" method="post" class="pure-form pure-form-aligned">

                   <label>How many lines to display?

                       <select name="lines" onchange="this.form.submit()">

                            <option value="10" <?php echo ($lines=='10') ? 'selected':'' ?>>10</option>

                            <option value="50" <?php echo ($lines=='50') ? 'selected':'' ?>>50</option>

                            <option value="100" <?php echo ($lines=='100') ? 'selected':'' ?>>100</option>

                            <option value="500" <?php echo ($lines=='500') ? 'selected':'' ?>>500</option>

                            <option value="1000" <?php echo ($lines=='1000') ? 'selected':'' ?>>1000</option>

                        </select>

                    </label>

                </form>

            </div>

            <div class="content">

                <ol reversed>

                    <?= outputlog($filename,$lines) ?>

                </ol>

            </div>

        </div>

    </div>

</body>

<?php



/*

 / Checking the access permission.

*/

function granaccess($grantAccess){

    if(empty($grantAccess) && empty($_SESSION['grantAccess'])){

        die("403 Forbidden or No Permission to Access.");

    }else{

        if($grantAccess == md5('payvyne')){

            $_SESSION['grantAccess'] = md5('payvyne');

            $url = strtok($_SERVER['REQUEST_URI'], '?');

            header('Location: '.$url);

            exit;

        }

    }

}



/*

 / getting log of the files.

*/

function outputlog($filename,$lines){

    $output = tail($filename, $lines);

    if ($output){

        $output = explode("\n", $output);

        if(DISPLAY_REVERSE){

            $output = array_reverse($output);

        }

        $output = implode('</pre><li><pre>', $output);

        return $output;

    }

}



/*

 / Clear tug log.

*/

function clearlog($clear,$filename){

    if($clear == 1){

        file_put_contents($filename, '');

        $url = strtok($_SERVER['REQUEST_URI'], '?');

        header('Location: '.$url);

        exit;

    }

}



/*

 / getting log file path.

*/

function getlogfilepath(){

    $dirpath = dirname( __FILE__ );

    $root = substr($dirpath, 0, strpos($dirpath, "wp-content"));

    $file = $root.'log'.DIRECTORY_SEPARATOR.'payvyne.log';

    $dirname = dirname($file);



    if (!is_dir($dirname)) {

        mkdir($dirname, 0777, true); // true for recursive create

    }



    if (!file_exists($file)){

        $fh = fopen($file, 'w+') or die("Can't create file");

    }



    return $file;

}



/*

 / Reading the file from the end.

*/

function tail($filename, $lines = 50, $buffer = 4096){

	// Open the file

	if(!is_file($filename)){

		return false;

	}



	$f = fopen($filename, "rb");

	if(!$f){

		return false;

	}

	

	// Jump to last character

	fseek($f, -1, SEEK_END);



	// Read it and adjust line number if necessary

	// (Otherwise the result would be wrong if file doesn't end with a blank line)

	if(fread($f, 1) != "\n") $lines -= 1;



	$output = '';

	$chunk = '';



	while(ftell($f) > 0 && $lines >= 0)

	{

		$seek = min(ftell($f), $buffer);

		fseek($f, -$seek, SEEK_CUR);

		$output = ($chunk = fread($f, $seek)).$output;

		fseek($f, -mb_strlen($chunk, '8bit'), SEEK_CUR);

		$lines -= substr_count($chunk, "\n");

	}



	while($lines++ < 0)

	{

		$output = substr($output, strpos($output, "\n") + 1);

	}



	fclose($f);

	return $output;

}

?>

</html>
