<?php 

/**

 * The core plugin class.

 *

 * This is used to define internationalization, admin-specific hooks, and

 * public-facing site hooks.

 *

 * Also maintains the unique identifier of this plugin as well as the current

 * version of the plugin.

 *

 * @since      1.0.0

 * @package    WC_PayVyne_Payment_Gateway

 * @subpackage WC_PayVyne_Payment_Gateway/includes/

 */

return array(

	'enabled' => array(

		'title' => __( 'Enable/Disable', 'payvyne' ),

		'type' => 'checkbox',

		'label' => __( 'Enable Method', 'payvyne' )

	),

	'title' => array(

		'title' => __( 'Title*', 'payvyne' ),

		'type' => 'text',

		'desc_tip'    => true,

		'description' => __( 'This controls the title which the user see during checkout.', 'payvyne' ),

		'default'     => 'Payvyne'

	),

	'description' => array(

		'title'       => __( 'Description', 'payvyne' ),

		'type'        => 'text',

		'desc_tip'    => true,

		'description' => __( 'This controls the description which the user see during checkout.', 'payvyne' ),

		'default'     => 'Pay via Payvyne'

	),

	'img_details' => array(

		'title'       => __( 'Image Configration', 'payvyne' ),

		'type'        => 'title',

	),

	'display_image' => array(

		'title' => __( 'Show Image', 'payvyne' ),

		'type'        => 'select',

		'options'     => array('yes' => "Yes","no" => "No"),

		'label' => __( 'Show Images', 'payvyne' ),

		'default'     => 'no',

	),

	'payment_image' => array(

		'title' => __( 'Image (base64)', 'payvyne' ),

		'type' => 'text',

		'description' => __( 'This controls the image which the user sees during checkout.', 'payvyne' ),

		'label' => __( 'Image', 'payvyne' )

	),

	'test_details' => array(

		'title'       => __( 'API Configration', 'payvyne' ),

		'type'        => 'title',

	),

	'test_mode' => array(

		'title' => __( 'Sandbox Mode', 'payvyne' ),

		'type' => 'checkbox',

		'label' => __( 'Enable Sandbox Mode', 'payvyne' )

	),

	'redirect_type' => array(

		'title'       => __( 'Redirect Type', 'payvyne' ),

		'type'        => 'select',

		'options'     => array('QR' => "QR", "URL" => "URL"),

		'description' => __( 'Define the redirect type.', 'payvyne' ),

		'desc_tip'    => true,

		'default'     => 'URL',

	),

	'order_status' => array(

		'title' => __( 'Order Status After The Checkout', 'payvyne' ),

		'type' => 'select',

		'options' => wc_get_order_statuses(),

		'default' => 'wc-on-hold',

		'description' 	=> __( 'The default order status if this gateway used in payment.', 'payvyne' ),

	),

	
	'api_details' => array(

		'title'       => __( 'API details', 'payvyne' ),

		'type'        => 'title',

	),

	'client_id' => array(

		'title' => __( 'Client id', 'payvyne' ),

		'type' => 'text',

		'description' => __( 'Client id', 'payvyne' ),

		'desc_tip'      => true,

	),

	'client_secret' => array(

		'title' => __( 'Client Secret', 'payvyne' ),

		'type' => 'text',

		'description' => __( 'Client Secret', 'payvyne' ),

		'desc_tip'      => true,

	),

	'bank_account' => array(

		'title' => __( 'Destination account', 'payvyne' ),

		'type' => 'text',

		'description' => __( 'Destination account', 'payvyne' ),

		'desc_tip'      => true,

	),

	

	'api_details_test' => array(

		'title'       => __( 'API details', 'payvyne' ),

		'type'        => 'title',

	),

	'sandbox_client_id' => array(

		'title' => __( 'Client id (Sandbox)', 'payvyne' ),

		'type' => 'text',

		'description' => __( 'Sandbox Client id', 'payvyne' ),

		'desc_tip'      => true,

	),

	'sandbox_client_secret' => array(

		'title' => __( 'Client Secret (Sandbox)', 'payvyne' ),

		'type' => 'text',

		'description' => __( 'Sandbox Client Secret', 'payvyne' ),

		'desc_tip'      => true,

	),

	'sandbox_bank_account' => array(

		'title' => __( 'Destination account', 'payvyne' ),

		'type' => 'text',

		'description' => __( 'Destination account', 'payvyne' ),

		'desc_tip'      => true,

	),

	'debug_details' => array(

		'title'       => __( 'Debug Settings', 'payvyne' ),

		'type'        => 'title',

	),

	'log_mode' => array(

		'title' => __( 'Enable Logging', 'payvyne' ),

		'type' => 'checkbox',

		'description' => __( 'log file located at wp root directory<b>/log/payvyne.log</b>. if file is missing then you need to check the permission.', 'payvyne' ),

		'label' => __( 'Debug Log ', 'payvyne' )

	),

	'log_view' => array(

		'title' => __( 'View Log', 'payvyne' ),

		'type' => 'button',

		'default' => __( 'View Log ', 'payvyne' )

	),

	'custom_script'=> array(

		'type' => 'custom_script'

	)

);